/*
 * Copyright 2002 Draagon Software LLC. All Rights Reserved.
 *
 * This software is the proprietary information of Draagon Software LLC.
 * Use is subject to license terms.
 */

package com.draagon.meta;

import java.util.ArrayList;
import java.util.Collection;


/**
 * An attribute of a MetaClass, MetaField, or MetaView
 */
public abstract class MetaAttribute extends MetaData
{
  //private static Log log = LogFactory.getLog( MetaAttribute.class );

  /**
   * Constructs the MetaClass
   */
  public MetaAttribute()
  {
  }

  /**
   * Gets the primary MetaData class
   */
  public final Class<?> getMetaDataClass()
  {
    return MetaAttribute.class;
  }

  /**
   * Retrieves the attribute options expected for this class; empty in this case
   */
  public Collection<AttributeOption> getAttributeOptions()
  {
    return new ArrayList<AttributeOption>();
  }

  /**
   * Sets the value of the MetaAttribute
   */
  public abstract void setValue( Object value )
    throws InvalidAttributeValueException;

  /**
   * Returns the value of the MetaAttribute
   */
  public abstract Object getValue();
}
