/*
 * Copyright 2003-2004 Draagon Software LLC. All Rights Reserved.
 *
 * This software is the proprietary information of Draagon Software LLC.
 * Use is subject to license terms.
 */

package com.draagon.meta;


public interface StatefulMetaClass
{
  ///////////////////////////////////////////////////////////////
  // Object State Methods

  public abstract boolean isNew( Object obj ) throws MetaException;
  public abstract boolean isModified( Object obj ) throws MetaException;
  public abstract boolean isDeleted( Object obj ) throws MetaException;

  public abstract void setNew( Object obj, boolean state ) throws MetaException;
  public abstract void setModified( Object obj, boolean state ) throws MetaException;
  public abstract void setDeleted( Object obj, boolean state ) throws MetaException;

  public abstract long getCreationTime( Object obj ) throws MetaException;
  public abstract long getModifiedTime( Object obj ) throws MetaException;
  public abstract long getDeletedTime( Object obj ) throws MetaException;

  /**
   * Returns whether the field on the object was modified
   */
  public abstract boolean isFieldModified( MetaField f, Object obj ) throws MetaException;

  /**
   * Sets whether the field is modified
   */
  public abstract void setFieldModified( MetaField f, Object obj, boolean state ) throws MetaException;

  /**
   * Gets the time the field was modified
   */
  public abstract long getFieldModifiedTime( MetaField f, Object obj ) throws MetaException;
}
