package com.draagon.meta.attr;

import java.io.IOException;
import java.io.StringReader;
import java.util.Properties;

import com.draagon.meta.InvalidAttributeValueException;
import com.draagon.meta.MetaAttribute;

public class PropertiesAttribute extends MetaAttribute {

	private static final long serialVersionUID = -1385348596313826808L;
	
	private Properties props = new Properties();
	
	public PropertiesAttribute() {		
	}

	public PropertiesAttribute( Properties p ) {
		props = p;
	}

	@Override
	public Object getValue() {
		return props;
	}

	@Override
	public void setValue( Object value ) throws InvalidAttributeValueException {
		try {
			props.load( new StringReader( value.toString() ));
		} catch (IOException e) {
			throw new InvalidAttributeValueException( "Could not load properties [" + value + "]: " + e.getMessage(), e );
		}
	}

	public Object clone()
	{
		PropertiesAttribute pa = (PropertiesAttribute) super.clone();
	    pa.props = props;
	    return pa;
	}
}
