/*
 * Copyright 2002 Draagon Software LLC. All Rights Reserved.
 *
 * This software is the proprietary information of Draagon Software LLC.
 * Use is subject to license terms.
 */

package com.draagon.meta.attr;

import com.draagon.meta.*;


/**
 * An attribute of a MetaClass, MetaField, or MetaView
 */
@SuppressWarnings("serial")
public class StringAttribute extends MetaAttribute
{
  //private static Log log = LogFactory.getLog( StringAttribute.class );

  private String mString = null;

  /**
   * Constructs the MetaClass
   */
  public StringAttribute()
  {
  }

  public StringAttribute(String name, String value) {
	setName( name );
	setValue( value );
  }

  /**
   * Sets the value of the MetaAttribute
   */
  public void setValue( Object value )
    throws InvalidAttributeValueException
  {
    mString = value.toString();
  }

  /**
   * Returns the value of the MetaAttribute
   */
  public Object getValue()
  {
    return mString;
  }

  public Object clone()
  {
    StringAttribute sa = (StringAttribute) super.clone();
    sa.mString = mString;
    return sa;
  }
}
